<template>
  <div>
    <div
      v-if="loading"
      class="d-flex justify-center align-center"
      style="height: 80vh"
    >
      <v-progress-circular :indeterminate="true" />
    </div>
    <div v-else>
      <v-row>
        <v-col cols="6">
          <h1 class="line__title display-3">
            Line
            <metrocheck-line-icon
              :id="parseInt(this.$props.number, 10)"
              style="font-size: 1.2rem"
            />
          </h1>
        </v-col>
      </v-row>

      <v-row>
        <div class="line__map">
          <metrocheck-map
            v-if="hydrated"
            :bounds="mapBbox"
            :max-bounds="maxBounds"
          >
            <metrocheck-layer-lines-simple
              :displayed-lines="[parseInt($props.number, 10)]"
              :dashes="false"
            />
            <!--            <metrocheck-layer-lines :displayed-lines="[parseInt($props.number, 10)]" />-->
            <metrocheck-layer-points :displayed-lines="[parseInt($props.number, 10)]" />
          </metrocheck-map>
        </div>
      </v-row>

      <v-row>
        <v-col cols="12">
          <v-subheader>Frequency</v-subheader>
          <metrocheck-frequency-chart
            id="line"
            :chart-data="stats.frequency"
          />
        </v-col>
      </v-row>
    </div>
  </div>
</template>

<script>
  import { fetchLineStatistics } from '../../../api'
  import { mapState } from 'vuex'
  import MetrocheckFrequencyChart from '../../../components/FrequencyChart'
  import MetrocheckMap from '../../../components/Map/Map'
  import MetrocheckLayerLinesSimple from '../../../components/Map/LayerLinesSimple'
  import MetrocheckLayerPoints from '../../../components/Map/LayerPoints'
  import { mutations } from '../../../store/constants'
  import { bbox } from '@turf/turf'
  import mapboxgl from 'mapbox-gl'
  import MetrocheckLineIcon from '../../../components/LineIcon'
  import statsMixin from '../../../mixins/stats'
  import config from '../../../../config'

  export default {
    name: 'MetrocheckStatsLine',

    components: {
      MetrocheckLineIcon,
      MetrocheckFrequencyChart,
      MetrocheckMap,
      MetrocheckLayerPoints,
      MetrocheckLayerLinesSimple,
    },

    mixins: [statsMixin],

    props: {
      number: { type: [String, Number], required: true },
    },

    data: function () {
      return {
        loading: true,
      }
    },

    computed: {
      ...mapState(['lineStatistics', 'geojsonSources', 'hydrated']),

      stats: function () {
        return this.lineStatistics && this.lineStatistics[this.date] ? this.lineStatistics[this.date][this.$props.number] : { directions: [] }
      },
      formattedDirection: function () {
        const dir = new Map()
        this.stats.directions.forEach(d => {
          // Unknown points
          if (!d.name_fr) {
            d.name_fr = '?'
          }

          // Store directions in a Map <PointName, PointIds[]>
          if (!dir.has(d.name_fr)) {
            dir.set(d.name_fr, [])
          }
          dir.set(d.name_fr, dir.get(d.name_fr).concat([{ id: d.id, percentage: d.percentage }]))
        })

        return dir
      },
      mapBbox: function () {
        if (this.geojsonSources[this.$props.number]) {
          const arrBbox = bbox(this.geojsonSources[this.$props.number].features[0])
          // const arrBbox = [4.464598, 50.857309, 4.319423, 50.837625]
          const bounds = new mapboxgl.LngLatBounds(
            new mapboxgl.LngLat(arrBbox[0], arrBbox[1]),
            new mapboxgl.LngLat(arrBbox[2], arrBbox[3]),
          )
          console.log(arrBbox, bounds)
          // return bounds
          return bounds
        }
        console.warn('no geojson source found yet !')
        return null
      },
      // Widen max bounds as map is displayed with a low height/width ratio
      maxBounds: function () {
        return config.map.maxBounds.map((v, i) => [v[0] + (i === 0 ? -0.2 : 0.2), v[1]])
      },
    },

    watch: {
      lineStatistics: function () { console.debug('lineStatistics change seen. Doing nothing.') },
    },

    async created () {
      return this.fetchData()
    },

    methods: {
      fetchData: async function () {
        try {
          const line = this.$props.number

          const statistics = await fetchLineStatistics(line, this.date)
          await this.$store.commit(mutations.SET_LINE_STATISTIC, { date: this.date, line, statistics })
        } catch (e) {
          console.error(e)
        }

        this.loading = false
      },
    },
  }
</script>
